#!/usr/bin/sh

WASDOMAIN="Total Computing Domain"
WAS_HOME=/usr/WebSphere/AppServer
WAS_CLASSPATH=$WAS_HOME/properties:$WAS_HOME/lib/bootstrap.jar

# WAS commands
STARTWAS=/usr/WebSphere/AppServer/bin/startupServer.sh
ADMINCLIENT=/usr/WebSphere/AppServer/bin/adminclient.sh
STOPWAS=
WSCP=/usr/WebSphere/AppServer/bin/wscp.sh
ASSEMBLY=
EAREXPANDER=
SEAPPINSTALL=
SOAPENABLER=
CLIENTCONFIG=
DRADMIN=
DUMPNAMESPACE=
JSPCOMPILER=/usr/WebSphere/AppServer/bin/JspBatchCompiler.sh
LAUNCHCLIENT=

XMLCONFIG=/usr/WebSphere/AppServer/bin/XMLConfig.sh

# A list of all the Commands set above
WASCOMMANDS="STARTWAS(startupServer.sh) ADMINCLIENT(adminclient.sh) WSCP(wscp.sh) JSPCOMPILER(JspBatchCompiler.sh) XMLCONFIG(XMLConfig.sh)"

# WAS Installed/Installable directory
INSTALLEDAPPS=
INSTALLABLEAPPS=

# Port assignments
ADMINPORT=900
DRADMINPORT=7000

PATH=/usr/WebSphere/AppServer/bin:$PATH
LD_LIBRARY_PATH=$WAS_HOME/lib/odbc/lib:$LD_LIBRARY_PATH
LD_LIBRARY_PATH=$WAS_HOME/bin:$WAS_HOME/lib:$LD_LIBRARY_PATH

export PATH LD_LIBRARY_PATH
export WASDOMAIN WAS_HOME INSTALLEDAPPS INSTALLABLEAPPS ADMINPORT DRADMINPORT WASCOMMANDS
export ADMINCLIENT STARTWAS STOPWAS WSCP ASSEMBLY EAREXPANDER SEAPPINSTALL SOAPENABLER CLIENTCONFIG DRADMIN DUMPNAMESPACE JSPCOMPILER LAUNCHCLIENT XMLCONFIG

