import java.sql.*;
import java.io.*;

class StructureEmpPwd {

    static {
        try {
            Class.forName("COM.ibm.db2.jdbc.net.DB2Driver");
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void main(String argv[]) {
        try {
            Connection conn;
            Connection local;
            String url = "jdbc:db2://node2.tcnd.com:50068/DBGUIDE";

            System.out.println("Trying to connect.");
            // connect
            conn = DriverManager.getConnection(url, "dbuser", "pwd007");
            Statement stmt = conn.createStatement();
            ResultSet rs = stmt.executeQuery("SELECT * FROM DB2INST1.EMPPWD");
            String createstring = "CREATE TABLE DB2INST1.EMPPWD (";
            ResultSetMetaData md = rs.getMetaData();
            int n = md.getColumnCount();
            int k = 0;
            for (int i = 1; i <= n; i++) {
                createstring += md.getColumnName(i) + " ";
                switch (md.getColumnType(i)) {
                case 1: 
                    createstring += "CHAR(" + md.getPrecision(i) + ")";
                    k = md.getPrecision(i);
                    break;
                case 2:
                    createstring += "INTEGER";
                    k = md.getPrecision(i);
                    break;
                case 3:
                    createstring += "DECIMAL(" + md.getPrecision(i) + ", " + md.getScale(i) + ")";
                    if (md.getScale(i) != 0) {
                        k = md.getPrecision(i) + 1 + md.getScale(i);
                    } else {
                        k = md.getPrecision(i);
                    }
                    break;
                case 4:
                    createstring += "DATE";
                    k = md.getPrecision(i);
                    break;
                case 5:
                    createstring += "LOGICAL";
                    k = md.getPrecision(i);
                    break;
                case 12:
                    createstring += "VARCHAR(" + md.getPrecision(i) + ")";
                    if (md.getScale(i) != 0) {
                        k = md.getPrecision(i) + 1 + md.getScale(i);
                    } else {
                        k = md.getPrecision(i);
                    }
                    break;
                case 91:
                    createstring += "CHAR(10)";
                    k = 10;
                    break;
                case 93:
                    createstring += "TIMESTAMP NOT NULL WITH DEFAULT";
                    break;
                default:
                    System.err.println("Unknown type : " + md.getColumnType(i));
                    k = 0;
                    break;
                }
                if (i < n) {
                    createstring += ",";
                }
            }
            createstring += ")";

            System.out.println(createstring);

            stmt.close();
            conn.close();
        } catch ( Exception e ) {
            e.printStackTrace();
        }
    }
}
