import java.util.Hashtable;

import com.tcnd.wasdg.dataaccess.*;
import com.tcnd.wasdg.common.*;

class Ex10AccountRetrieval
{

	public static void main(String args[])
	{
		DataAccessComponent DAC = new DataAccessComponent();
		IDataAccessObject iDAO = DAC.createDAObject();

		Hashtable hs = new Hashtable();

		System.out.println("*** 1- Fetching an employee (teller) account from EMPACCNT table:");
		hs.put("userid","teller1");
		iDAO.setParameters(hs);

		iDAO.setCommandString("SELECT * FROM DB2INST1.EMPACCNT WHERE USERID = ':userid'");
		iDAO = DAC.fetchEmpAccount(iDAO);
		if (iDAO.getCommandResult()) {
			EmpAccnt aEmp = iDAO.getEmpAccnt();
			aEmp.show();
		}


		System.out.println("*** 2- Fetching a client account from CLIACCNT table:");
		hs.put("clientid","client1");
		iDAO.setParameters(hs);
		iDAO.setCommandString("SELECT * FROM DB2INST1.CLIACCNT WHERE CLIENTID = ':clientid'");
		iDAO = DAC.fetchCliAccount(iDAO);
		if (iDAO.getCommandResult())
		{
			CliAccnt aCli = iDAO.getCliAccnt();
			aCli.show();
			System.out.println("The first name of the client with cliendid client1: " + aCli.getFrstName());
		}

		System.out.println("*** 3- Getting an employee (teller) password:");
		hs.put("userid","teller1");
		iDAO.setParameters(hs);

		iDAO.setCommandString("SELECT PASSWORD FROM DB2INST1.EMPPWD WHERE USERID = ':userid'");
		iDAO = DAC.executeQuery(iDAO);
		if (iDAO.getCommandResult()) {
			DataSet dataSet = iDAO.getDataSet();
			dataSet.seekFirstRow();
			System.out.println("The employee teller1 password is :" + dataSet.getValue("password"));
		}
		else {
			System.out.println("The employee teller11 password is: AUTHENTICATION FAILED!");
		}

		System.out.println("*** 4- Getting an employee (teller) password:");
		hs.put("userid","teller1");
		hs.put("password","secret11");
		iDAO.setParameters(hs);

		iDAO.setCommandString("SELECT * FROM DB2INST1.EMPPWD WHERE (USERID = ':userid' AND PASSWORD = ':password')");
		iDAO = DAC.executeQuery(iDAO);
		if (iDAO.getCommandResult()) {
			DataSet dataSet = iDAO.getDataSet();
			dataSet.seekFirstRow();
			System.out.println("The employee teller1 password is :" + dataSet.getValue("password"));
		}
		else {
			System.out.println("The employee teller1 password is: AUTHENTICATION FAILED!");
		}

	}
}
