import java.util.Hashtable;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import javax.servlet.http.HttpServlet;

import javax.rmi.*;
import javax.naming.*;
import javax.ejb.*;
import java.util.*;
import com.tcnd.wasdg.ejb.MapRequest;
import com.tcnd.wasdg.ejb.creditdebit.*;

import com.tcnd.wasdg.ejb.dataaccess.CliAccnt;
import com.tcnd.wasdg.common.StrTool;

public class CreditDebit9 extends javax.servlet.http.HttpServlet {
	InitialContext jndiCtx;
	CreditDebitHomeRemote fHome = null;
	CreditDebitRemote fRemote = null;
	
	String step1content =
"<HTML>" + 
"<HEAD>" + 
"<TITLE>WASDG - Debit/Credit FORM</TITLE>" + 
"</HEAD>" + 
"<BODY>" + 
"<H1>CREDIT/DEBIT a ClientID</H1>" + 
"<FORM METHOD=\"POST\" ACTION=\"/wasbook/creditdebit9\">" + 
"<input type=\"hidden\" name=\"JSESSIONID\" value=\"ziff_HIDDEN_JSESSIONID\">" +
"" + 
"<HR>" + 
"<H2>Please enter the ClientID and the amount to credit/debit: </H2>" + 
"<font size=-1>(i.e. to debit $20 you will enter -20)</font>" + 
"<P>ClientID:<INPUT TYPE=\"text\" NAME=\"clientid\" SIZE=\"20\">" + 
"<P>Amount:<INPUT TYPE=\"text\" NAME=\"amount\" SIZE=\"20\">" + 
"<HR>" + 
"<INPUT TYPE=\"submit\" VALUE=\"Submit\"><INPUT TYPE=\"reset\">" + 
"</FORM>" + 
"</BODY>" + 
"</HTML>" + 
"";  
	
	String step2content =
"<HTML>" + 
"<HEAD>" + 
"<TITLE>WASDG - Show Client Account FORM</TITLE>" + 
"</HEAD>" + 
"<BODY>" + 
"<H1>Show Client Account Record</H1>" + 
"<FORM>" + 
"" + 
"<HR>" + 
"<H2>The client account record for CLIENTID=ziff_CLIENTID</H2>" + 
"<P><font size=\"+1\">ClientID:  ziff_CLIENTID</font>" + 
"<P><font size=\"+1\">BankID:  ziff_BANKID</font>" + 
"<P><font size=\"+1\">Category:  ziff_CATEGORY</font>" + 
"<P><font size=\"+1\">RempID:  ziff_REMPID</font>" + 
"<P><font size=\"+1\">First Name:  ziff_FRSTNAME</font>" + 
"<P><font size=\"+1\">Last name:  ziff_LASTNAME</font>" + 
"<P><font size=\"+1\">Email:  ziff_EMAIL</font>" + 
"<hr>" + 
"<P><font size=\"+1\">Debit Count:  ziff_CDEBITS</font>" + 
"<P><font size=\"+1\">Credit Count:  ziff_CCREDITS</font>" + 
"<P><font size=\"+1\">Balance:  </font><font size=\"+1\" color=\"blue\">ziff_BALANCE</font>" + 
"<P><font size=\"+1\">Juggle:</font><font size=\"+1\" color=\"blue\">c ziff_CLIENTID:b ziff_BALANCE:d# ziff_CDEBITS:c# ziff_CCREDITS:</font>" + 
"<HR>" + 
"</FORM>" + 
"</BODY>" + 
"</HTML>" + 
"";
	
public void init() throws ServletException {
	try
	{
		// Get System properties for JNDI initialization
		java.util.Properties properties = new java.util.Properties();
		properties.put(javax.naming.Context.PROVIDER_URL, "iiop:///");
		properties.put(javax.naming.Context.INITIAL_CONTEXT_FACTORY,"com.ibm.websphere.naming.WsnInitialContextFactory");
		// Form an initial context
		jndiCtx = new InitialContext(properties);
		java.lang.Object o = jndiCtx.lookup("CreditDebit");
		fHome = (CreditDebitHomeRemote)javax.rmi.PortableRemoteObject.narrow(o, CreditDebitHomeRemote.class);
		fRemote = fHome.create();
		System.out.println("Good CreditDebit9 -- init() after create");
	} 
	catch (Exception e)
	{ 	
		System.out.println("CreditDebit servlet error when retrieving the home interface: " + e.getMessage());
	}
}

public void doGet(HttpServletRequest request, HttpServletResponse response) 
	throws ServletException, IOException 
{
	response.setContentType("text/html");
	response.setHeader("Pragma", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setDateHeader("Expires", 0);

	PrintWriter out = response.getWriter();
	out.println(step1content);
	out.close();
}	


public void doPost(HttpServletRequest request, HttpServletResponse response) 
	throws ServletException, IOException 
{
	String content = "Hmmm!";

	MapRequest mReq = new MapRequest();
	CliAccnt aCli = null;

	String clientid = request.getParameter("clientid");
	String amount = request.getParameter("amount");

	mReq.setParam("clientid",clientid);
	mReq.setParam("amount",amount);

	try
	{
		aCli = fRemote.creditdebit(mReq);
		System.out.println("Good -- After fRemote.creditdebit()");
	}
	catch (Exception e)
	{
		System.out.println("CreditDebit servlet error: " + e.getMessage());
	}
	if (aCli != null)
	{
		// Fill in the HTML presentation
		content = step2content;
		content = StrTool.replaceUnsensitive(content, "ziff_CLIENTID", aCli.getClientID());
		content = StrTool.replaceUnsensitive(content, "ziff_BANKID", aCli.getBankID());
		content = StrTool.replaceUnsensitive(content, "ziff_CATEGORY", aCli.getCategory());
		content = StrTool.replaceUnsensitive(content, "ziff_REMPID", aCli.getRempID());
		content = StrTool.replaceUnsensitive(content, "ziff_FRSTNAME", aCli.getFrstName());
		content = StrTool.replaceUnsensitive(content, "ziff_LASTNAME", aCli.getLastName());
		content = StrTool.replaceUnsensitive(content, "ziff_EMAIL", aCli.getEmail());
		content = StrTool.replaceUnsensitive(content, "ziff_CDEBITS", String.valueOf(aCli.getCdebits()));
		content = StrTool.replaceUnsensitive(content, "ziff_CCREDITS", String.valueOf(aCli.getCcredits()));
		content = StrTool.replaceUnsensitive(content, "ziff_BALANCE", String.valueOf(aCli.getBalance()));
	}
	response.setContentType("text/html");
	response.setHeader("Pragma", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setDateHeader("Expires", 0);
	PrintWriter out = response.getWriter();
	out.println(content);
	out.close();
}
}

