import java.io.*;
import java.util.*;
import java.lang.*;

import javax.crypto.*;
import javax.crypto.spec.*;


/**
* fetch the signed file: java Dfile filename password
**/

class Dfile {

public static void main(String argv[]) {

	String signedfn = argv[0];
	String content = getSignedFile(argv[1],signedfn);
	System.out.println(content);
}


public static String getSignedFile(String password, String fn) {
	String stream = "";
	try {
		byte[] salt = { 
			(byte) 0x35, (byte)0x46,
			(byte) 0x25, (byte)0xc6,
			(byte) 0x85, (byte)0xa6,
			(byte) 0xe5, (byte)0x16
		};
		PBEParameterSpec pbeParamSpec = new PBEParameterSpec(salt, 20);
		char[] secret = (password).toCharArray();
		PBEKeySpec keySpec = new PBEKeySpec(secret);
		SecretKeyFactory keyFac = SecretKeyFactory.getInstance("PBEWithMD5AndDES");
		SecretKey sKey = keyFac.generateSecret(keySpec);
		
		Cipher cipher = Cipher.getInstance("PBEWithMD5AndDES");
		cipher.init(Cipher.DECRYPT_MODE,sKey,pbeParamSpec);
		FileInputStream fin = new FileInputStream(fn);
		ObjectInputStream oin = new ObjectInputStream(fin);
		SealedObject sealed = (SealedObject) oin.readObject();
		stream = (String) sealed.getObject(cipher);
	} catch (Exception e) {
		System.out.println("Encryption error:"+e);
	}
	return stream;
}

}

