import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

import javax.crypto.*;
import javax.crypto.spec.*;

import com.tcnd.wasdg.common.*;

public class CipheredReg extends javax.servlet.http.HttpServlet {
	String content =

"<HTML>" + 
"<HEAD>" + 
"<TITLE>WASDG Application (Chapter 20) - Protected Registration with Cipher</TITLE>" + 
"</HEAD>" + 
"<BODY>" + 
"<H1>This registration page is ciphered. Provide password to proceed.</H1>" + 
"<FORM METHOD=\"POST\" ACTION=\"/wasbook/cipheredreg\">" + 
"" + 
"<HR>" + 
"<H2>The default registration page is set below but you need to provide the password:</H2>" + 
"<font size=-1>(This registration page has been ciphered with pwd123, then enter pwd123 as password)</font>" + 
"<P>File name:<INPUT TYPE=\"text\" NAME=\"fname\" VALUE=\"reg_client.signed\" SIZE=\"20\">" + 
"<P>Signature:<INPUT PASSWORD=\"text\" NAME=\"password\" SIZE=\"20\">" +
"<HR>" + 
"<INPUT TYPE=\"submit\" VALUE=\"Fetch\"><INPUT TYPE=\"reset\">" + 
"</FORM>" + 
"</BODY>" + 
"</HTML>" + 
""; 


public void doGet(HttpServletRequest request, HttpServletResponse response) 
		throws IOException{

	ServletOutputStream out = response.getOutputStream();

	response.setContentType("text/html");
	response.setHeader("Pragma", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setDateHeader("Expires", 0);

	out.println(content);
}

public void doPost(HttpServletRequest request, HttpServletResponse response) 
		throws IOException{

	String fname = request.getParameter("fname");
	ServletContext context = getServletContext();
	String fromdir = context.getInitParameter("fromdir");
	String password = request.getParameter("password");

	String content = getSignedFile(password,fromdir + fname);
	ServletOutputStream out = response.getOutputStream();

	response.setContentType("text/html");
	response.setHeader("Pragma", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setDateHeader("Expires", 0);

	out.println(content);
}


public static String getSignedFile(String password, String fn) {
	String stream = null;
	try {
		byte[] salt = { 
			(byte) 0x35, (byte)0x46,
			(byte) 0x25, (byte)0xc6,
			(byte) 0x85, (byte)0xa6,
			(byte) 0xe5, (byte)0x16
		};
		PBEParameterSpec pbeParamSpec = new PBEParameterSpec(salt, 20);
		char[] secret = (password).toCharArray();
		PBEKeySpec keySpec = new PBEKeySpec(secret);
		SecretKeyFactory keyFac = SecretKeyFactory.getInstance("PBEWithMD5AndDES");
		SecretKey sKey = keyFac.generateSecret(keySpec);
		
		Cipher cipher = Cipher.getInstance("PBEWithMD5AndDES");

		cipher.init(Cipher.DECRYPT_MODE,sKey,pbeParamSpec);
		FileInputStream fin = new FileInputStream(fn);
		ObjectInputStream oin = new ObjectInputStream(fin);
		SealedObject sealed = (SealedObject) oin.readObject();
		stream = (String) sealed.getObject(cipher);
	} catch (Exception e) {
		System.out.println("Encryption error:"+e);
	}
	return stream;
}

}
