import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import javax.servlet.http.HttpServlet;

import com.tcnd.wasdg.dataaccess.*;
import com.tcnd.wasdg.common.*;

public class QueryTable extends javax.servlet.http.HttpServlet {
	DataAccessComponent DAC;

public void init() throws ServletException {
	DAC = new DataAccessComponent();
}

public void doGet(HttpServletRequest request, HttpServletResponse response) 
		throws ServletException, IOException {

	String dbTable = request.getParameter("table");

	System.out.println(">>>>> " + dbTable);
	IDataAccessObject iDAO = DAC.createDAObject();

	iDAO.setCommandString("SELECT * FROM DB2INST1." + dbTable);
	iDAO = DAC.executeQuery(iDAO);
	DataSet dataSet = iDAO.getDataSet();

	response.setContentType("text/html");
	response.setHeader("Pragma", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setDateHeader("Expires", 0);

	PrintWriter out = response.getWriter();
	out.println("<html><head><title>WASDG Title Page</title></head><body> &nbsp;<center><table BORDER=0 CELLPADDING=2 ><tr><td></td>");
	

	if (dataSet.getRowCount() > 0)
	{
		for (int i = 0; i < dataSet.getColumnCount(); i++)
		{
			out.println("<td ALIGN=CENTER BGCOLOR=\"#E0D224\"><font size=+2>" + i + "&nbsp;</font></td>");
		}
		out.println("<tr><td></td>");
		
		dataSet.seekFirstRow();
		for (int j = 0; j < dataSet.getRowCount(); j++)
		{
			for (int i = 0; i < dataSet.getColumnCount(); i++)
			{
				out.println("<td ALIGN=CENTER BGCOLOR=\"#E0D1B4\"><font size=+1>" + dataSet.getValue(i) + "&nbsp;</font></td>");
			}
			out.println("<tr><td></td>");
			dataSet.seekNextRow();
		} 
	}
	else
	{	
		out.println( "</tr>");
	}
	out.println("</table></body></html>");
	out.close();
}

public void doPost(HttpServletRequest request, HttpServletResponse response)
              throws ServletException, IOException
{
	doGet( request, response);
}
}
	
