package com.tcnd.wasdg.dbreg;

import javax.security.auth.*;
import javax.security.auth.callback.*;
import javax.security.auth.login.*;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.Hashtable;
// import com.tcnd.wasdg.dataaccess.*;
import com.tcnd.wasdg.common.*;

public class Logout extends javax.servlet.http.HttpServlet 
{
    static class NullCallbackHandler implements CallbackHandler 
    {
        public void handle(Callback[] cb) 
	{
	    // we won't implement this one
            throw new IllegalArgumentException("Not implemented.");
        }
    }

    static LoginContext lc = null;


	DataAccessComponent DAC;


public void init() throws ServletException
{
	System.out.println(" > INIT Logout!");
        // use the configured LoginModules for the Logout
        try 
	{
           lc = new LoginContext("Logout", new NullCallbackHandler());
        } 
	catch (LoginException le) 
	{
		// throw exception -1
            le.printStackTrace();
        } 
        try 
	{
            lc.login();
            // At this point the authenticated user can execute the code
	    // Get the privileged object holding the authorization to the DBGUIDE
	    // specifially for the principal dbreg, and instantiate a DAC
           DbguideAuth dbregObj = (DbguideAuth)Subject.doAs(lc.getSubject(), new PrivilegedDbregAuth());
	   // Show to standard output for learning reason onlyr, must be deleted otherwise.
	   dbregObj.show();
	   DAC = new DataAccessComponent(dbregObj);

        } 
	catch (Exception e) 
	{
		// throw exception -1
            System.out.println("Login failed: " + e);
        }
	// getting this far means login OK
}



public void doGet(HttpServletRequest request, HttpServletResponse response) 
		throws IOException{
	String content = null;

	HttpSession session = request.getSession(true);
	// make sure to get rid of the session
	if (session.isNew() == false) {
		content = "LOGOUT: TMLOGOUT updated and session invalidated. Bye!";
		// Update the login time in two statements
		EmpAccnt aEmp = (EmpAccnt)session.getAttribute("teller");
		IDataAccessObject iDAO = DAC.createDAObject();
		iDAO.setCommandString("UPDATE DB2INST1.EMPPWD SET TMLOGOUT = (CURRENT TIMESTAMP) WHERE USERID = '" + aEmp.getUserID() + "'");
		iDAO = DAC.executeUpdate(iDAO);
		session.invalidate();
	}
	else {
		content = "Not in session... Bye anyway!";
	}

	response.setContentType("text/html");
	response.setHeader("Pragma", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setDateHeader("Expires", 0);

	ServletOutputStream out = response.getOutputStream();
	out.println(content);
	out.close();
}
}
