package com.tcnd.wasdg.dbreg;

import java.security.*;
import java.util.*;
import java.io.*;

import com.tcnd.wasdg.common.*;

public class PrivilegedDbregAuth implements PrivilegedAction
{
	public Object run()
	{
		DbguideAuth au = new DbguideAuth();

		final String dbguidePropertiesFileName="/BOOK/20/dbreg_sysprotected/update_emppwd_dbguide.properties";

		java.util.Properties prop;
		prop = new Properties();
		try
		{
			prop.load(new FileInputStream(dbguidePropertiesFileName));
		} catch (Exception e)
		{
			e.printStackTrace();
		}

		au.setDbDriver(prop.getProperty("dbdriver"));
		au.setDbUrl(prop.getProperty("dburl"));
		au.setDbUser(prop.getProperty("dbuser"));
		au.setDbPassword(prop.getProperty("dbpassword"));

		return (DbguideAuth) au;
	}
}
