package com.tcnd.wasdg.dbreg;

import javax.security.auth.*;
import javax.security.auth.callback.*;
import javax.security.auth.login.*;
import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class ZenFile extends HttpServlet 
{
    static class NullCallbackHandler implements CallbackHandler 
    {
        public void handle(Callback[] cb) 
	{ 
	    // we won't implement this one
            throw new IllegalArgumentException("Not implemented.");
        }
    }

    static LoginContext lc = null;
    String content = null;

public void init() throws ServletException
{
	System.out.println(" > INIT ZenFile!");
        try 
	{
           lc = new LoginContext("ZenFile", new NullCallbackHandler());
        } 
	catch (LoginException le) 
	{
		// throw exception -1
            le.printStackTrace();
        } 
        try 
	{
            lc.login();
            // At this point the authenticated user can execute the code
            content = (String)Subject.doAs(lc.getSubject(), new PrivilegedFetchFile());
	    System.out.println("FETCHED FILE CONTENT: " + content);

        } 
	catch (Exception e) 
	{
   	   // throw exception -1
            System.out.println("Login failed: " + e);
        }
	// getting this far means login OK and more code can be written at this point
}

	public void doGet (HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException 
	{
		PrintWriter out;
		res.setContentType("text/html");
		out = res.getWriter();
		out.println("<HTML><HEAD><TITLE> Testing JAAS</TITLE></HEAD>" +
			"<BODY><P><CENTER><H2> Content of file is: </H2>" +
			"<H1> " + content + " </H1><HR><P></HTML>");
	}
}
