import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class FlipSession extends HttpServlet
{
		
	public void doGet (HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException 
	{
		PrintWriter out;
		res.setContentType("text/html");
		out = res.getWriter();

		// get current session object (creating one if not found)
		HttpSession session = req.getSession(); // same as req.getSession(true);
		if (session.isNew()) {
			out.println("You are not in session but I have just created one: " + session.getId()  + "!");
		}
		else
		{
			out.println("You were in session (" + session.getId() + ") but I have just invalidated it!");
			session.invalidate();
		}
	}
}

