import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class DumpEnv extends HttpServlet {

public void service(HttpServletRequest request, HttpServletResponse response)
	throws ServletException, IOException {

	ServletOutputStream out = response.getOutputStream();
	response.setContentType("text/html");
	response.setHeader("Pragma", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setDateHeader("Expires", 0);

	String content = 
	"<html><head><title>WASDG - Common Form Information</title></head>" +
	"<body><h1>Form Information</h1>" +
	"HTML Method: " + request.getMethod() + "<br>" +
	"URI: " + request.getRequestURI() + "<br>" +
	"Protocol: " + request.getProtocol() + "<br>" +
	"Servlet Path: " + request.getServletPath() + "<br>" +
	"Path Info: " + request.getPathInfo() + "<br>" +
	"Path Translated: "+request.getPathTranslated()+"<br>" +
	"Query String: " + request.getQueryString() + "<br>" +
	"Content Length: "+request.getContentLength()+"<br>" +
	"Content Type: " + request.getContentType() + "<br>" +
	"Server name: " + request.getServerName() + "<br>" +
	"Server port: " + request.getServerPort() + "<br>" +
	"Remote User: " + request.getRemoteUser() + "<br>" +
	"Remote Address: "+request.getRemoteAddr()+"<br>" +
	"Remote Host: " + request.getRemoteHost() + "<br>" +
	"Authentication Scheme: "+request.getAuthType()+"<br>" +
	"<hr><p>";

	out.println(content);

	Enumeration names = request.getHeaderNames();
	while (names.hasMoreElements()) {

		String header = (String) names.nextElement();
		out.println(header + ": " + request.getHeader(header) + "<br>");
	}

	names = request.getParameterNames();
	out.println("<hr><p>");
	while (names.hasMoreElements()) {
		String key = (String)names.nextElement();
		String [] values = (String []) request.getParameterValues(key);
		if (values != null) {
			out.println("KEY: " + key + "VALUES: ");
			for (int i = 0; i < values.length; i++)
				out.println(values[i] + " ");
			out.println("<br>");
		}
	}

	out.close();
}

}
