import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.Hashtable;

public class Logoff extends javax.servlet.http.HttpServlet {

public void init() throws ServletException { }

public void doGet(HttpServletRequest request, HttpServletResponse response) 
		throws IOException
{
	String content = "Bye.";

	HttpSession session = request.getSession(true);
	// make sure to get rid of a staled session
	if (session.isNew() == false) {
		System.out.println("LOG OUT. No staled session, invalidation in progress...");
		session.invalidate();
		// do not uncomment below, as this will create session record in the database. Careful!
		// session = request.getSession(true);
	}
	response.setContentType("text/html");
	response.setHeader("Pragma", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setDateHeader("Expires", 0);

	ServletOutputStream out = response.getOutputStream();
	out.println(content);
	out.close();
}
}
