import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class PostCookie extends HttpServlet {
	public void doGet (HttpServletRequest request, HttpServletResponse response)
	throws ServletException, IOException 
	{
		PrintWriter out;
		response.setContentType("text/html");
		out = response.getWriter();

		String sessvalue = request.getParameter("sessvalue");
		String sesstime = request.getParameter("sesstime");

		Cookie c = new Cookie("SESSIONID", sessvalue);
		c.setMaxAge(Integer.parseInt(sesstime)); // Netscape's most popular, 1 for RFC 2109 experimental
		c.setDomain("node1.tcnd.com");
		c.setPath("/"); //c.setPath("/wasbook/");
		c.setVersion(0);
		c.setSecure(false);

		response.addCookie(c);

		String content = "<HTML><HEAD><TITLE> Testing PostCookie </TITLE></HEAD>" +
			"<BODY><P><CENTER><H1>This cookie will expire in: " + sesstime + " seconds</H1><HR><P></HTML>";
		out.println(content);
	}
	public void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException
	{
         	doGet(request,response);
	}
}
