import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class ResetSession extends HttpServlet {
		
	public void doGet (HttpServletRequest request, HttpServletResponse response)
	throws ServletException, IOException {

	 String content1 = "<HTML><HEAD><TITLE> Testing TestSession </TITLE></HEAD>" +
	 	"<BODY><P><CENTER><H1> First time in session </H1><HR><P></HTML>";

	 String content2 = "<HTML><HEAD><TITLE> Testing TestSession </TITLE></HEAD>" +
	 	"<BODY><P><CENTER><H1> I invalidated your session and created a new one.</H1><HR><P></HTML>";

	
		PrintWriter out;
		response.setContentType("text/html");
		out = response.getWriter();

		// create a new session	
		HttpSession session = request.getSession(true);
		// if session is new (user not in session) then create one
		if (session.isNew() == true) {
			out.println(content1);
		}
		else 
		{
			// invalidate and create a new session with three (attr,obj) pairs
			session.invalidate();
			session = request.getSession();
			// session.setMaxInactiveInterval(5); // 5 seconds ! zapp it
			String s1 = "Bonjour monsieur!"; // a first string as an object
			String s2 = "Bonjour madame!"; // a second string as an object
			session.setAttribute("a1",s1); // a1-to-object s1
			session.setAttribute("a2",s2); // a2-to-object s2
			session.setAttribute("a3",s2); // a3-to-object s2
			out.println(content2);
		}
	}
}

