import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class SetCookie extends HttpServlet 
{
		
	public void doGet (HttpServletRequest request, HttpServletResponse response)
	throws ServletException, IOException 
	{
		PrintWriter out;
		// set mime type
		response.setContentType("text/html");
		out = response.getWriter();

		String someName = "SESSIONID";
		String someValue = "12345";

		Cookie c = new Cookie(someName, someValue);
		c.setValue("123456");
		c.setVersion(0); // Netscape's most popular, 1 for RFC 2109 experimental
		c.setDomain(".tcnd.com");
		c.setPath("/wasbook/"); 
		c.setMaxAge(15); // expire in 15 seconds
		c.setSecure(false); // not secure
		// VERSION 1 only   c.setComment("a comment goes here");

		response.addCookie(c);

		String content = "<HTML><HEAD><TITLE> Testing SetCookie </TITLE></HEAD>" +
			"<BODY><P><CENTER><H1>Test SetCookie</H1><HR><P></HTML>";
		out.println(content);
	}
}

