import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import javax.rmi.*;
import javax.naming.*;
import javax.ejb.*;
import java.util.*;
import com.tcnd.wasdg.ejb.MapRequest;
import com.tcnd.wasdg.ejb.operationemp.*;


import com.tcnd.wasdg.ejb.dataaccess.EmpAccnt; // casting problem otherwise
// The above EmpAccnt object should be imported from the same package as the one
// that will be used in other servlets. Other servlet will use the EmpAccnt object
// in the session, the object is com.tcnd.wasdg.ejb.dataaccess.EmpAccnt. Otherwise
// type casting problem will be thrown by WAS run time. To verify the validity of
// this argument, login as teller from /wasbook/login9, and select the "Dump Session"
// (/wasbook/dumpsession) from the teller activity screen. Look up the error in $WASLOG_STDOUT.


// The following imports are not needed anymore because the business logic is handled by the bean and
// not in the servlet itself. Compare with TellerLogged servlet.
// import com.tcnd.wasdg.common.IDataAccessObject;
// import com.tcnd.wasdg.common.DataSet;
import com.tcnd.wasdg.common.StrTool;


public class TellerLogged9 extends javax.servlet.http.HttpServlet 
{
	InitialContext jndiCtx;
	OperationEmpHomeRemote fHome = null;
	OperationEmpRemote fRemote = null;

	String pagecontent =

	"<html>" + 
	"<head>" + 
	"<page name=\"tellerlogged.html\" />" + 
	"<title>WebSphere Application Server Programming, Teller Logged OK: ziff_WELCOMETELLER</title>" + 
	"<ON:page name=\"tellerlogged\"/>" + 
	"<style>" + 
	"BODY,TD {font-family:arial,helv,sans-serif;font-size:10pt}" + 
	"</style>" + 
	"" + 
	"</head>" + 
	"<body text=\"#000000\" bgcolor=\"#ffffff\" link=\"990000\" alink=\"009900\" leftmargin=\"0\" marginheight=\"0\" marginwidth=\"0\" rightmargin=\"0\" topmargin=\"0\" bottommargin=\"5\">" + 
	"<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"760\" align=\"center\">" + 
	"<tr>" + 
	"</tr>" + 
	"</table>" + 
	"<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"760\" align=\"center\">" + 
	"<tr><td bgcolor=\"#000000\" height=\"3\" colspan=\"3\"><img src=\"/img/_.gif\" alt=\"\" width=\"1\" height=\"1\" hspace=\"0\" vspace=\"1\" border=\"0\"></td></tr>" + 
	"<tr valign=\"top\">" + 
	"<td width=\"150\" bgcolor=\"#cccccc\">" + 
	"<img src=\"/img/wasprog.gif\" alt=\"\" width=\"150\" height=\"80\" hspace=\"0\" vspace=\"0\" border=\"0\">" + 
	"&nbsp;" + 
	"</td>" + 
	"" + 
	"<td width=\"590\">" + 
	"" + 
	"<img src=\"/img/wb-teller-in-session-ejb.gif\" alt=\"Teller in Session\" width=\"150\" height=\"36\" hspace=\"0\" vspace=\"0\" border=\"0\">" + 
	"<br><hr width=\"590\" color=\"#cc0000\" >" + 
	"" + 
	"<content>" + 
	"" + 
	"<font face=\"arial,helvetica,geneva,sans-serif\">" + 
	"<font size=\"+2\">" + "WELCOME TELLER: ziff_WELCOMETELLER" + "</font><br>" +
	"<font size=\"-1\">" + 
	"<p>" + 
	"<b>Note:</b> WebSphere Application Server Programming." + 
	"Testing Enterprise JavaBeans." + 
	"" + 
	"<table border=\"0\" cellpadding=\"0\" cellspacing=\"10\">" + 
	"" + 
	"<tr><td>" + 
	"<font face=\"arial,helvetica,geneva,sans-serif\" size=\"+2\" >Click here to DEBIT/CREDIT <a href=\"http://ziff_SERVERNAME/wasbook/creditdebit9\">client balance (EJB)." + 
	"</font></td></tr>" + 
	"" + 
	"<tr><td>" + 
	"<font face=\"arial,helvetica,geneva,sans-serif\" size=\"+2\" >Click here to edit <a href=\"http://ziff_SERVERNAME/wasbook/editteller9\">your profile (EJB)." + 
	"</font></td></tr>" + 
	"" + 
	"<tr><td>" + 
	"<font face=\"arial,helvetica,geneva,sans-serif\" size=\"+2\" >Click here to <a href=\"http://ziff_SERVERNAME/wasbook/dumpenv\">dumpenv (OK)." + 
	"</font></td></tr>" + 
	"<tr><td>" + 
	"<font face=\"arial,helvetica,geneva,sans-serif\" size=\"+2\" >Click here to <a href=\"http://ziff_SERVERNAME/wasbook/dumpcook\">dumpcook (OK)." + 
	"</font></td></tr>" + 
	"<tr><td>" + 
	"<font face=\"arial,helvetica,geneva,sans-serif\" size=\"+2\" >Click here to <a href=\"http://ziff_SERVERNAME/wasbook/dumpsession\">dumpsession (Failure due to casting)." + 
	"</font></td></tr>" + 
	"<tr><td>" + 
	"<font face=\"arial,helvetica,geneva,sans-serif\" size=\"+2\" >Click here to <a href=\"http://ziff_SERVERNAME/wasbook/logoff\">logoff (OK, invalidate session in w.c.)." + 
	"</font></td></tr>" + 
	"<tr><td>" + 
	"<font face=\"arial,helvetica,geneva,sans-serif\" size=\"+2\" >Click here to <a href=\"http://ziff_SERVERNAME/wasbook/logout9\">logout (EJB with time update.)" + 
	"</font></td></tr>" + 
	"<tr><td>" + 
	"<font face=\"arial,helvetica,geneva,sans-serif\" size=\"+2\" >Click on the <a href=\"http://ziff_SERVERNAME/wasbook/sessionfairy9\">Session Fairy (Modify for proper casting)." + 
	"</font></td></tr>" + 
	"" + 
	"<tr><td><font face=\"arial,helvetica,geneva,sans-serif\" size=\"-1\">Last Login:(ziff_LASTTIMELOGGEDIN)</font></td>" + 
	"<td colspan=\"3\"><size=\"20\" maxlength=\"50\"></td></tr>" + 
	"<tr><td><font face=\"arial,helvetica,geneva,sans-serif\" size=\"-1\">Last Logout:(ziff_LASTTIMELOGGEDOUT)</font></td>" + 
	"<td colspan=\"3\"><size=\"20\" maxlength=\"50\"></td></tr>" + 
	"<tr><td><font face=\"arial,helvetica,geneva,sans-serif\" size=\"-1\">Current SessionID:(ziff_FILLINSESSIONID)</font></td>" + 
	"<td colspan=\"3\"><size=\"20\" maxlength=\"50\"></td></tr>" + 
	"<!--userchoice-->" + 
	"<tr><td><font face=\"arial,helvetica,geneva,sans-serif\" size=\"-1\">&nbsp;</font></td>" + 
	"<td colspan=\"3\">" + 
	"&nbsp;</td></tr>" + 
	"</table>" + 
	"" + 
	"<p>" + 
	"" + 
	"</content>" + 
	"" + 
	"</td>" + 
	"</tr>" + 
	"<tr valign=\"middle\" align=\"center\"><td bgcolor=\"#cccccc\" height=\"20\" colspan=\"3\">&nbsp; " + 
	"<!-- #include virtual=\"/inc/footer.ssi\"-->&nbsp;</td></tr>" + 
	"</table>" + 
	"<!--   #include virtual=\"/inc/copyright.ssi\"-->" + 
	"</body>" + 
	"</html>";


	public void init() throws ServletException {
	try
	{
		// Get System properties for JNDI initialization
		java.util.Properties properties = new java.util.Properties();
		properties.put(javax.naming.Context.PROVIDER_URL, "iiop:///");
		properties.put(javax.naming.Context.INITIAL_CONTEXT_FACTORY,"com.ibm.websphere.naming.WsnInitialContextFactory");
		// Form an initial context
		jndiCtx = new InitialContext(properties);
		java.lang.Object o = jndiCtx.lookup("OperationEmp");
		fHome = (OperationEmpHomeRemote)javax.rmi.PortableRemoteObject.narrow(o, OperationEmpHomeRemote.class);
		fRemote = fHome.create();
		System.out.println("Good TellerLogged9 -- init() after create");
	} 
	catch (Exception e)
	{ 	
		System.out.println("TellerLogged9 servlet error when retrieving the home interface: " + e.getMessage());
	}
	}


	public void doGet(HttpServletRequest request, HttpServletResponse response) 
		throws ServletException, IOException 
	{
		response.setContentType("text/html");
		response.setHeader("Pragma", "no-cache");
		response.setHeader("Cache-Control", "no-cache");
		response.setDateHeader("Expires", 0);
		PrintWriter out = response.getWriter();
		out.println("Hmm!");
		out.close();
	}	

	public void doPost(HttpServletRequest request, HttpServletResponse response) 
		throws IOException
	{
		String content = "Hmm!";

		String userid = request.getParameter("userid");
		String password = request.getParameter("password");

		MapRequest mReq = new MapRequest();
		mReq.setOperation("__OPERATIONEMP_LOGIN__"); // BOGO
		mReq.setParam("userid",userid);
		mReq.setParam("password",password);
		try
		{
			EmpAccnt aEmp = new EmpAccnt();
			aEmp = fRemote.execute(mReq);
			System.out.println("Good -- After fRemote.execute()");
			if (aEmp != null)
			{
			// create a new session
			HttpSession session = request.getSession(true);
			// make sure to get rid of a staled session
			if (session.isNew() == false) {
				session.invalidate();
				session = request.getSession(true);
			}
			System.out.println("If session persistence is enabled then the following will write to the datastore");
			session.setAttribute("teller",aEmp);
	
			content = pagecontent;
	 		content = StrTool.replaceUnsensitive( content, "ziff_WELCOMETELLER", userid + "(" + aEmp.getFrstName() + ")");
			content = StrTool.replaceUnsensitive( content, "ziff_SERVERNAME", request.getServerName());
			content = StrTool.replaceUnsensitive( content, "ziff_URLREWRITE", response.encodeURL("/wasbook/urlrewrite") );
			content = StrTool.replaceUnsensitive( content, "ziff_LASTTIMELOGGEDIN", aEmp.getTmLogin());
			content = StrTool.replaceUnsensitive( content, "ziff_LASTTIMELOGGEDOUT", aEmp.getTmLogout());
			content = StrTool.replaceUnsensitive( content, "ziff_FILLINSESSIONID", session.getId());
			}
		}
		catch (Exception e)
		{
			System.out.println("TellerLogged9 servlet error: " + e.getMessage());
		}
			
		response.setContentType("text/html");
		response.setHeader("Pragma", "no-cache");
		response.setHeader("Cache-Control", "no-cache");
		response.setDateHeader("Expires", 0);

		ServletOutputStream out = response.getOutputStream();
		out.println(content);
		out.close();
	}
}
