import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.Hashtable;

import com.tcnd.wasdg.dataaccess.*;
import com.tcnd.wasdg.common.*;


public class UpdateProfile extends javax.servlet.http.HttpServlet 
{
	DataAccessComponent DAC;

	public void init() throws ServletException {
		DAC = new DataAccessComponent();
	}

	public void doGet(HttpServletRequest request, HttpServletResponse response) 
		throws ServletException, IOException 
	{
		response.setContentType("text/html");
		response.setHeader("Pragma", "no-cache");
		response.setHeader("Cache-Control", "no-cache");
		response.setDateHeader("Expires", 0);

		PrintWriter out = response.getWriter();

		out.println("Hmm!");
		out.close();
	}	

	public void doPost(HttpServletRequest request, HttpServletResponse response) 
		throws IOException
	{
		// check if in session first
		HttpSession session = request.getSession();
		EmpAccnt aEmp = (EmpAccnt)session.getAttribute("teller");

		String userid = aEmp.getUserID(); // get userid from the session set by TellerLogged
		// the following parameters need to be read from the request because they may have been changed
		String frstname = request.getParameter("firstname");
		String lastname = request.getParameter("lastname");
		String email = request.getParameter("email");
		String contact = request.getParameter("contact");

		IDataAccessObject iDAO = DAC.createDAObject();

		Hashtable hs = new Hashtable();
		hs.put("userid",userid);
		hs.put("frstname",frstname);
		hs.put("lastname",lastname);
		hs.put("email",email);
		hs.put("contact",contact);
		iDAO.setParameters(hs);
		iDAO.setCommandString("UPDATE DB2INST1.EMPACCNT SET FRSTNAME = ':frstname' , LASTNAME = ':lastname' , EMAIL = ':email' , CONTACT = ':contact' WHERE USERID = ':userid'");
		iDAO = DAC.executeUpdate(iDAO);
		if (iDAO.getCommandResult()) 
		{
			// update the EmpAccnt object if the UPDATE was successful
			aEmp.setFrstName(frstname);
			aEmp.setLastName(lastname);
			aEmp.setEmail(email);
			aEmp.setContact(contact);
		}
		aEmp.show();
		ServletOutputStream out = response.getOutputStream();
		out.print("Teller userid: " + aEmp.getUserID());
		out.print("<br>Firstname: " + aEmp.getFrstName());
		out.print("<br>Lastname: " + aEmp.getLastName());
		out.print("<br>Email: " + aEmp.getEmail());
		out.print("<br>Contact: " + aEmp.getContact());
		out.close();
	}
}
