package com.tcnd.wasdg.ejb;

import javax.naming.*;
import javax.rmi.*;
import com.tcnd.wasdg.ejb.dataaccess.*;
import com.tcnd.wasdg.ejb.dataaccess.idac.*;
import com.tcnd.wasdg.ejb.fetchtable.*;
import com.tcnd.wasdg.ejb.creditdebit.*;
import com.tcnd.wasdg.ejb.operationemp.*;
// import com.tcnd.wasdg.wasdgexceptions.WasdgException;

public class HmLookup
{
	static private DataAccessComponentHomeRemote dacHomeRemote = null;

	static private FetchTableHomeRemote fetchtableHomeRemote = null;
	static private IDACFetchTableHomeRemote idac_fetchtableHomeRemote = null;

	static private CreditDebitHomeRemote creditdebitHomeRemote = null;
	static private IDACCreditDebitHomeRemote idac_creditdebitHomeRemote = null;

	static private OperationEmpHomeRemote operationempHomeRemote = null;
	static private IDACOperationEmpHomeRemote idac_operationempHomeRemote = null;

public static Object getHome(String beanAlias) // throws WasdgException
{
	try
	{
		if (beanAlias.equals("DataAccessComponent"))
		{
			if (dacHomeRemote == null)
				dacHomeRemote = (DataAccessComponentHomeRemote)getNarrowedClass("DataAccessComponent", DataAccessComponentHomeRemote.class);
			return dacHomeRemote;
		}

		if (beanAlias.equals("FetchTable"))
		{
			if (fetchtableHomeRemote == null)
				fetchtableHomeRemote = (FetchTableHomeRemote)getNarrowedClass("FetchTable", FetchTableHomeRemote.class);
			return fetchtableHomeRemote;
		}
		if (beanAlias.equals("IDACFetchTable"))
		{
			if (idac_fetchtableHomeRemote == null)
				idac_fetchtableHomeRemote = (IDACFetchTableHomeRemote)getNarrowedClass("IDACFetchTable", IDACFetchTableHomeRemote.class);
			return idac_fetchtableHomeRemote;
		}

		if (beanAlias.equals("CreditDebit"))
		{
			if (creditdebitHomeRemote == null)
				creditdebitHomeRemote = (CreditDebitHomeRemote)getNarrowedClass("CreditDebit", CreditDebitHomeRemote.class);
			return creditdebitHomeRemote;
		}
		if (beanAlias.equals("IDACCreditDebit"))
		{
			if (creditdebitHomeRemote == null)
				idac_creditdebitHomeRemote = (IDACCreditDebitHomeRemote)getNarrowedClass("IDACCreditDebit", IDACCreditDebitHomeRemote.class);
			return idac_creditdebitHomeRemote;
		}

		if (beanAlias.equals("OperationEmp"))
		{
			if (operationempHomeRemote == null)
				operationempHomeRemote = (OperationEmpHomeRemote)getNarrowedClass("OperationEmp", OperationEmpHomeRemote.class);
			return operationempHomeRemote;
		}
		if (beanAlias.equals("IDACOperationEmp"))
		{
			if (idac_operationempHomeRemote == null)
				idac_operationempHomeRemote = (IDACOperationEmpHomeRemote)getNarrowedClass("IDACOperationEmp", IDACOperationEmpHomeRemote.class);
			return idac_operationempHomeRemote;
		}
	}
//	catch (WasdgException e1)
//	{
//		throw e1;
//	}
	catch (Exception e2)
	{
//		throw new WasdgException("MMMM0000E");
	}
	return null;
}

private static Object getNarrowedClass(String jndiName, Class className) // throws WasdgException
{
	Object ro = null;
	try
	{
		Context jndiCtx = new InitialContext();
		Object o = jndiCtx.lookup(jndiName);
		ro = PortableRemoteObject.narrow(o, className);
	}
	catch (Exception e)
	{
//		throw new WasdgException("MMMM0000E");
	}
	return ro;
}
}
