import java.net.*;
import java.io.*;

public class HelloURL
{
	public HelloURL()
	{
		super();
	}

	public void printHelloURL( String helloUrlStr )
	{
		URL url = null;
		BufferedReader reader = null;
		String data = null;

		try {
			url = new URL(helloUrlStr);
			reader = new BufferedReader(new InputStreamReader(url.openStream()) );
			while ((data = reader.readLine()) != null )
			{
				System.out.println(data);
			}
		} 
		catch (MalformedURLException e) {
			e.printStackTrace();
		} 
		catch (IOException e) {
			e.printStackTrace();
		}
	}

	public static void main(String args[]) {
		// localhost may be changed to the remote HTTP server
		String url = "http://localhost/HelloWorld.html";
		HelloURL o = new HelloURL();
		o.printHelloURL(url);
	}
}


