DB2DIR="/usr/IBMdb2/V7.1"

DB2INSTANCE=db2inst1
export DB2INSTANCE

INSTHOME=/home/db2inst1

DB2_PATH=`echo ${PATH}: | sed \
         -e "s/:[^:]*sqllib\/bin[^:]*:/:/"   \
         -e "s/:[^:]*sqllib\/adm[^:]*:/:/"   \
         -e "s/:[^:]*sqllib\/misc[^:]*:/:/"  \
         -e "s/\(.*\):$/\1/"                 \
         -e "s/^:\(.*\)/\1/"                 \
         -e "s/::*/:/g"`

DB2_PATH=${DB2_PATH}:${INSTHOME}/sqllib/bin:${INSTHOME}/sqllib/adm
DB2_PATH=${DB2_PATH}:${INSTHOME}/sqllib/misc
export DB2_PATH

#-----------------------------------------------------------------------
# UDB Extender initialization
#-----------------------------------------------------------------------
if [ -f ${INSTHOME}/dmb/dmbprofile ]; then
    . ${INSTHOME}/dmb/dmbprofile
fi

#-----------------------------------------------------------------------
# The following variables are used for JDBC support
#-----------------------------------------------------------------------
#-----------------------------------------------------------------------
# Only add sqlj.zip if SDK is installed
#-----------------------------------------------------------------------
##CLASSPATH=${CLASSPATH:-""}

if [ -f ${INSTHOME}/sqllib/java/sqlj.zip ]; then
    DB2_CLASSPATH=${INSTHOME}/sqllib/java/sqlj.zip
##    CLASSPATH=$CLASSPATH:${INSTHOME}/sqllib/java/sqlj.zip
fi

if [ -d ${INSTHOME?}/sqllib/function ]
then
    DB2_CLASSPATH=$DB2_CLASSPATH:${INSTHOME}/sqllib/function
#    CLASSPATH=$CLASSPATH:${INSTHOME}/sqllib/function
fi

DB2_CLASSPATH=$DB2_CLASSPATH:${INSTHOME}/sqllib/java12/db2java.zip
#CLASSPATH=$CLASSPATH:${INSTHOME}/sqllib/java/db2java.zip
#CLASSPATH=$CLASSPATH:${INSTHOME}/sqllib/java/runtime.zip:.
export DB2_CLASSPATH

LD_LIBRARY_PATH=${LD_LIBRARY_PATH:-""}
LD_LIBRARY_PATH=$LD_LIBRARY_PATH:${INSTHOME}/sqllib/lib
LD_LIBRARY_PATH=$LD_LIBRARY_PATH:${INSTHOME}/sqllib/java12
export LD_LIBRARY_PATH

LIBPATH=${LIBPATH:-""}
LIBPATH=$LIBPATH:${INSTHOME}/sqllib/lib
LIBPATH=$LIBPATH:${INSTHOME}/sqllib/java12
export LIBPATH

