package com.tcnd.wasdg.common;

import java.io.*;

/**
 *
 * @author Bassem Jamaleddine
 * 
 */

public class StrTool
{

	public StrTool()
	{
		super();
	}

	public static String replaceSensitive(String s, String target, String repl)
	{

		int length = target.length();
		int i;

		// if no target given then return
		if ( repl.indexOf( target ) >= 0 )
			return s;

		for (i = s.indexOf(target);i>-1;i = s.indexOf(target))
		{
			StringBuffer strbfr = new StringBuffer();
			// copy from 0 up to the replacement point
			strbfr.append(s.substring(0,i));
			// insert the replacement
			strbfr.append(repl);
			// copy what's left of the string
			strbfr.append(s.substring(i+target.length()));

			s = strbfr.toString();

		}

		return s;
	}

	public static String replaceUnsensitive(String s, String target, String repl) 
	{
		int length = target.length();
		int i;

		// if no target given then return
		if ( repl.toUpperCase().indexOf( target.toUpperCase() ) >= 0 )
			return s;

		i = s.toUpperCase().indexOf(target.toUpperCase());
		while ( i >= 0 )
		{
			StringBuffer strbfr = new StringBuffer();
			// copy from 0 up to the replacement point
			strbfr.append(s.substring(0,i));
			// insert the replacement string
			strbfr.append(repl);
			// copy what's left of the string
			strbfr.append(s.substring(i+length));
			s = strbfr.toString();
			i = s.toUpperCase().indexOf(target.toUpperCase());
		}
		return s;
	}


	public static String getFile(String fn) 
	{
		String content = "";
		try 
		{
			RandomAccessFile file = new RandomAccessFile(fn,"r");
			long seek = 0;
			long length = file.length();
			while(seek < length) { 
				String s = file.readLine();
				content = content + s;
				seek = file.getFilePointer();
			}
		} catch (IOException e)
		{
			e.printStackTrace();
		}
		return content;
	}


	public static boolean isEmpty(Object str) 
	{
		return (str == null || str.toString().trim().length() == 0) ? true : false;
	}

}
