package com.tcnd.wasdg.dbreg;

import javax.security.auth.*;
import javax.security.auth.callback.*;
import javax.security.auth.login.*;
import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class FetchFile extends HttpServlet 
{
	static class NullCallbackHandler implements CallbackHandler 
	{
		public void handle(Callback[] cb) 
	{ 
		// certainly we won't implement this one
			throw new IllegalArgumentException("Not implemented.");
		}
	}

	static LoginContext lc = null;

	public void init() throws ServletException
	{
	System.out.println(" > INIT FetchFile!");
	try 
		{
			lc = new LoginContext("FetchFile", new NullCallbackHandler());
		} 
		catch (LoginException le) 
		{
			// throw exception -1
			le.printStackTrace();
		} 
		try 
		{
			lc.login();
			// At this point the authenticated user can execute the code
			String c = (String)Subject.doAs(lc.getSubject(), new PrivilegedFetchFile());
			System.out.println("FETCHED FILE CONTENT: " + c);

		} 
		catch (Exception e) 
		{
			// throw exception -1
			System.out.println("Login failed: " + e);
		}
	}

	public void doGet (HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException 
	{

		String content = "<HTML><HEAD><TITLE> Testing JAAS</TITLE></HEAD>" +
			"<BODY><P><CENTER><H1> Content of file is: </H1><HR><P></HTML>";
	 	
		PrintWriter out;
		res.setContentType("text/html");
		out = res.getWriter();
		out.println(content);
	}
}
