import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class DumpCook extends HttpServlet
{

    public void service(HttpServletRequest request, HttpServletResponse response)
	throws ServletException, IOException
    {
	ServletOutputStream out = response.getOutputStream();
	response.setContentType("text/html");
	out.println("<html><head><title>Dump cookies</title></head><body bgcolor=\"white\">");
	out.println("<h1>COOKIES and HEADER information</h1>");
	out.println("<h2>Cookies--</h2>");
	int j;
	Cookie[] cookies = request.getCookies();
	for (j=0; j< cookies.length; j++) {
	    // Fetch a cookie
	    Cookie aCookie = cookies[j];
	    String n = aCookie.getName();
            String v = aCookie.getValue();
	    // Looking for the cookie with SESSIONID
	    if (n.equals("SESSIONID")) {
		out.println("-- COOKIE[" + n + "][" + v + "] <br>");
	    }
	    else {
		out.println("COOKIE[" + n + "][" + v + "] <br>");
	    }
	}
	out.println("<hr><p>");
	out.println("<h2>Header--</h2>");
	out.println("Authentication Scheme: "+request.getAuthType()+"<br>");
	out.println("<p>");
	Enumeration names = request.getHeaderNames();
	while (names.hasMoreElements())
	    {
		String header = (String) names.nextElement();
		out.println(header + ": " + request.getHeader(header) + "<br>");
	    }
	out.close();
    }
}

