import com.tcnd.wasdg.log.Log;
import com.tcnd.wasdg.wasdgexceptions.WasdgException;

// Test exception handling with WasdgException: discarding old exceptions

class Test1 {

public static void main(String[] args) throws WasdgException
{
	Log.log("Test1.main: Call call_ABC() to catch and throw new exception");
	try 
	{ 
		call_ABC();
	}
	catch (WasdgException e1)
	{
		throw e1;
	}
}

// call_ABC() and call_BC() throw new exceptions while discarding the old ones
private static void call_ABC( ) throws WasdgException
{
	try
	{
		call_BC();
	}
	catch ( WasdgException e1 )
	{
		throw new WasdgException("DATA0001E");
	}
}

private static void call_BC( ) throws WasdgException
{	
	try
	{
		call_C();
	}
	catch ( WasdgException e1 )
	{
		throw new WasdgException("UREG0004E");
	}
}

private static void call_C( ) throws WasdgException
{
	throw new WasdgException("SESS0002E");
}
}
