// Auto processed file. CoveredIn uses TOC and ALAS

import java.util.Hashtable;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import javax.servlet.http.HttpServlet;
import com.tcnd.wasdg.common.StrTool;
public class CoveredIn extends javax.servlet.http.HttpServlet {
	String CURRENT_CHAPTER = "16";
	Hashtable toc = new Hashtable();
	Hashtable alas = new Hashtable();
	String content =
"<HTML>" + 
"<HEAD>" + 
"<TITLE>WASDG Application (Chapter ziff_CURRENTCHAPTER) - Page not implemented</TITLE>" + 
"</HEAD>" + 
"<BODY>" + 
"<H1>This page is not implemented in the current chapter.</H1>" + 
"<HR>" + 
"<H1>ziff_MESSAGE</H1>" + 
"<font size=-1>ziff_ALASMESSAGE</font>" + 
"<HR>" + 
"</BODY>" + 
"</HTML>" + 
""; 

public void init()
{
	toc.put("1","Introduction to IBM WAS Programming");
	toc.put("2","Installing the WAS Repository");
	toc.put("3","Setting Development Environment Prerequisites");
	toc.put("4","Installing WAS on Linux, Windows NT, and AIX");
	toc.put("5","Defining a WebSphere Domain");
	toc.put("6","Testing Your Installation");
	toc.put("7","WAS Report Extrapolation with Perl/WSCP");
	toc.put("8","A Quick and Essential Guide to Administering WAS");
	toc.put("9","Preparing the Database");
	toc.put("10","Accessing the Database in Java");
	toc.put("11","Developing a J2EE Web Application in WAS");
	toc.put("12","HTTP Servlet Programming");
	toc.put("13","Java Server Pages (JSP)");
	toc.put("14","The J2EE Web Application in WAS");
	toc.put("15","Classes in WAS");
	toc.put("16","Session Identification and the HTTP Protocol");
	toc.put("17","Session Scope and IBM Session Persistence");
	toc.put("18","Enterprise JavaBeans Programming");
	toc.put("19","Apache SOAP Programming in WAS");
	toc.put("20","Fundamental Security Programming");
	toc.put("21","Enterprise Application Development");
	toc.put("22","Stress-Testing");
	toc.put("23","Writing an Exception Handler, Logging, and Debugging");
	toc.put("24","WAS Monitoring with WASLED(tm) and WASMON(tm)");
	toc.put("25","Monitoring and Tuning the System Resources");
	toc.put("26","Risk Management with WASMON");
	toc.put("A","Retrieving Information and Code Distribution");
	toc.put("B","Backing Up and Restoring");
	toc.put("C","Demystifying Java 2's Internationalization with MrUnicode");
	toc.put("D","Gramercy Toolkit Scripts and the WASDG Environment");
	toc.put("E","WASLED/WASMON Quick Reference");
	toc.put("F","Support for WAS v5");

	alas.put("12","(Because HTTP session is not supported at this point, going back to the previous page may require a reload to repost the data.)");
	alas.put("13","(Because HTTP session is not supported at this point, going back to the previous page may require a reload to repost the data.)");
	alas.put("14","(Because HTTP session is not supported at this point, going back to the previous page may require a reload to repost the data.)");
	alas.put("15","(Because HTTP session is not supported at this point, going back to the previous page may require a reload to repost the data.)");
	alas.put("16","(HTTP session is supported at this point, go back to the activity screen by requesting the URI /wasbook/telleractivities)");
	alas.put("17","(HTTP session is supported at this point, go back to the activity screen by requesting the URI /wasbook/telleractivities)");
	alas.put("18","(HTTP session is supported at this point, go back to the activity screen by requesting the URI /wasbook/telleractivities)");
	alas.put("19","(HTTP session is supported at this point, go back to the activity screen by requesting the URI /wasbook/telleractivities)");
	alas.put("20","(HTTP session is supported at this point, go back to the activity screen by requesting the URI /wasbook/telleractivities)");
	alas.put("21","(HTTP session is supported at this point, go back to the activity screen by requesting the URI /wasbook/telleractivities)");
}
public void service(HttpServletRequest request, HttpServletResponse response) 
	throws ServletException, IOException {
	response.setContentType("text/html");
	response.setHeader("Pragma", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setDateHeader("Expires", 0);
	String currentchapter = CURRENT_CHAPTER;
	String nextchapter = request.getParameter("nextchapter");
	String msg;
	if (nextchapter.compareTo("99") == 0)
	{
		msg = "";
	}
	else {

		msg = "This page will be implemented in Chapter " + nextchapter + ": " + toc.get(nextchapter.toUpperCase())+ ".";
	}
	String c = StrTool.replaceUnsensitive(content, "ziff_CURRENTCHAPTER", currentchapter);
	c = StrTool.replaceUnsensitive(c, "ziff_MESSAGE", msg);
	c = StrTool.replaceUnsensitive(c, "ziff_ALASMESSAGE", (String)alas.get(currentchapter.toUpperCase()));

	PrintWriter out = response.getWriter();
	out.println(c);
	out.close();
}	
}
