
// #SIGNATURE#WASBOOK#

import java.util.Hashtable;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import javax.servlet.http.HttpServlet;

import com.tcnd.wasdg.dataaccess.*;
import com.tcnd.wasdg.common.*;

public class CreditDebit extends javax.servlet.http.HttpServlet {
	DataAccessComponent DAC;
	String step1content =
"<HTML>" + 
"<HEAD>" + 
"<TITLE>WASDG - Debit/Credit FORM</TITLE>" + 
"</HEAD>" + 
"<BODY>" + 
"<H1>CREDIT/DEBIT a ClientID</H1>" + 
"<FORM METHOD=\"POST\" ACTION=\"/wasbook/creditdebit\">" + 
"<input type=\"hidden\" name=\"JSESSIONID\" value=\"ziff_HIDDEN_JSESSIONID\">" +
"" + 
"<HR>" + 
"<H2>Please enter the ClientID and the amount to credit/debit: </H2>" + 
"<font size=-1>(i.e. to debit $20 you will enter -20)</font>" + 
"<P>ClientID:<INPUT TYPE=\"text\" NAME=\"clientid\" SIZE=\"20\">" + 
"<P>Amount:<INPUT TYPE=\"text\" NAME=\"amount\" SIZE=\"20\">" + 
"<HR>" + 
"<INPUT TYPE=\"submit\" VALUE=\"Submit\"><INPUT TYPE=\"reset\">" + 
"</FORM>" + 
"</BODY>" + 
"</HTML>" + 
"";  
	
	String step2content =
"<HTML>" + 
"<HEAD>" + 
"<TITLE>WASDG - Show Client Account FORM</TITLE>" + 
"</HEAD>" + 
"<BODY>" + 
"<H1>Show Client Account Record</H1>" + 
"<FORM>" + 
"" + 
"<HR>" + 
"<H2>The client account record for CLIENTID=ziff_CLIENTID</H2>" + 
"<P><font size=\"+1\">ClientID:  ziff_CLIENTID</font>" + 
"<P><font size=\"+1\">BankID:  ziff_BANKID</font>" + 
"<P><font size=\"+1\">Category:  ziff_CATEGORY</font>" + 
"<P><font size=\"+1\">RempID:  ziff_REMPID</font>" + 
"<P><font size=\"+1\">First Name:  ziff_FRSTNAME</font>" + 
"<P><font size=\"+1\">Last name:  ziff_LASTNAME</font>" + 
"<P><font size=\"+1\">Email:  ziff_EMAIL</font>" + 
"<hr>" + 
"<P><font size=\"+1\">Debit Count:  ziff_CDEBITS</font>" + 
"<P><font size=\"+1\">Credit Count:  ziff_CCREDITS</font>" + 
"<P><font size=\"+1\">Balance:  </font><font size=\"+1\" color=\"blue\">ziff_BALANCE</font>" + 
"<P><font size=\"+1\">Juggle:</font><font size=\"+1\" color=\"blue\">c ziff_CLIENTID:b ziff_BALANCE:d# ziff_CDEBITS:c# ziff_CCREDITS:</font>" + 
"<HR>" + 
"</FORM>" + 
"</BODY>" + 
"</HTML>" + 
"";
	
public void init() throws ServletException {
	DAC = new DataAccessComponent();

}

/*
public void doGet(HttpServletRequest request, HttpServletResponse response) 
	throws ServletException, IOException {
	response.setContentType("text/html");
	response.setHeader("Pragma", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setDateHeader("Expires", 0);

	PrintWriter out = response.getWriter();
	out.println(step1content);
	out.close();
}	


public void doPost(HttpServletRequest request, HttpServletResponse response) 
*/

public void service(HttpServletRequest request, HttpServletResponse response) 
	throws ServletException, IOException {

String content = "Hmmm!";

// Make sure that the teller is in session before making any transaction for a banker
HttpSession session = request.getSession(true);
if (session.isNew() == false) {
	String clientid = request.getParameter("clientid");
	String amount = request.getParameter("amount");

	IDataAccessObject iDAO = DAC.createDAObject();

	Hashtable hs = new Hashtable();
	hs.put("clientid",clientid);
	iDAO.setParameters(hs);
	iDAO.setCommandString("SELECT * FROM DB2INST1.CLIACCNT WHERE CLIENTID = ':clientid'");
	iDAO = DAC.fetchCliAccount(iDAO);
	if (iDAO.getCommandResult())
	{
		// get the client account
		CliAccnt aCli = iDAO.getCliAccnt();
		// Print the object to standard out, this will be printed to the default_server_stdout.log
		aCli.show();
		// get the balance, count of credits, count of debits
		int balance = aCli.getBalance();
		int ccredits = aCli.getCcredits();
		int cdebits = aCli.getCdebits();
		// add the number of bucks to the balance
		balance += Integer.parseInt(amount);
		// Increment the credits counter if it is 0 or more, the debits counter otherwise
		if (Integer.parseInt(amount) >= 0) ccredits += 1; else cdebits += 1;

		// update the balance, credits and debits counters in the database
		iDAO.setCommandString("UPDATE DB2INST1.CLIACCNT SET BALANCE = " + balance + " , CCREDITS = " + ccredits + " , CDEBITS = " + cdebits + " WHERE CLIENTID = ':clientid'");
		iDAO = DAC.executeUpdate(iDAO);
		if (iDAO.getCommandResult()) 
		{ 
			// update the CliAccnt object if the UPDATE was successful
			aCli.setBalance(balance);
			aCli.setCcredits(ccredits);
			aCli.setCdebits(cdebits);
			// Fill in the HTML presentation
			content = step2content;
			content = StrTool.replaceUnsensitive(content, "ziff_CLIENTID", aCli.getClientID());
			content = StrTool.replaceUnsensitive(content, "ziff_BANKID", aCli.getBankID());
			content = StrTool.replaceUnsensitive(content, "ziff_CATEGORY", aCli.getCategory());
			content = StrTool.replaceUnsensitive(content, "ziff_REMPID", aCli.getRempID());
			content = StrTool.replaceUnsensitive(content, "ziff_FRSTNAME", aCli.getFrstName());
			content = StrTool.replaceUnsensitive(content, "ziff_LASTNAME", aCli.getLastName());
			content = StrTool.replaceUnsensitive(content, "ziff_EMAIL", aCli.getEmail());
			content = StrTool.replaceUnsensitive(content, "ziff_CDEBITS", String.valueOf(aCli.getCdebits()));
			content = StrTool.replaceUnsensitive(content, "ziff_CCREDITS", String.valueOf(aCli.getCcredits()));
			content = StrTool.replaceUnsensitive(content, "ziff_BALANCE", String.valueOf(aCli.getBalance()));
		}
	}
}

	response.setContentType("text/html");
	response.setHeader("Pragma", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setDateHeader("Expires", 0);

	PrintWriter out = response.getWriter();
	out.println(content);
	out.close();
}
}
	
