import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.Hashtable;
import com.tcnd.wasdg.dataaccess.*;
import com.tcnd.wasdg.common.*;

public class Logout extends javax.servlet.http.HttpServlet 
{
DataAccessComponent DAC;

public void init() throws ServletException 
{
	DAC = new DataAccessComponent();
}

public void doGet(HttpServletRequest request, HttpServletResponse response) 
		throws IOException{
	String content = null;

	HttpSession session = request.getSession(true);
	// make sure to get rid of the session
	if (session.isNew() == false) {
		content = "LOGOUT: TMLOGOUT updated and session invalidated. Bye!";
		// Update the login time in two statements
		EmpAccnt aEmp = (EmpAccnt)session.getAttribute("teller");
		IDataAccessObject iDAO = DAC.createDAObject();
		iDAO.setCommandString("UPDATE DB2INST1.EMPPWD SET TMLOGOUT = (CURRENT TIMESTAMP) WHERE USERID = '" + aEmp.getUserID() + "'");
		iDAO = DAC.executeUpdate(iDAO);
		session.invalidate();
	}
	else {
		content = "Not in session... Bye anyway!";
	}
	response.setContentType("text/html");
	response.setHeader("Pragma", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setDateHeader("Expires", 0);

	ServletOutputStream out = response.getOutputStream();
	out.println(content);
	out.close();
}
}
