package com.tcnd.wasdg.ejb;

import java.util.Hashtable;

public class MapRequest implements java.io.Serializable 
{
	final static String opCodeToken = "__BEAN_OPCODE__";
	Hashtable ptReq = new Hashtable();

// MapRequest constructor
public MapRequest() 
{
	super();
}

public Hashtable getParamTable()
{
	return ptReq;
}

public String getParam(String pName) 
{
	if (!ptReq.containsKey(pName.toUpperCase())) 
		return null;
	else 
		return ptReq.get(pName.toUpperCase()).toString();
}

public void setParam(String pName, String pValue) 
{
	ptReq.put(pName.toUpperCase(), pValue);
}

public String getOperation() 
{
	if (!ptReq.containsKey(opCodeToken)) 
		return null;
	else 
		return ptReq.get(opCodeToken).toString();
}

public void setOperation(String opValue) 
{
	ptReq.put(opCodeToken, opValue);
}

// Use the BundleManager to get all these OPCODEs

/*
public Object getParamObj(String aParamName) 
{
	return ptReq.get(ptReq.get(aParamName.toUpperCase()));
}

public void setParamObj(String aParamName, Object aParamValue) 
{
	ptReq.put(aParamName.toUpperCase(), aParamValue);
}
*/
}
