package com.tcnd.wasdg.ejb.dataaccess.idac;

import com.tcnd.wasdg.common.DataSet;
import com.tcnd.wasdg.ejb.dataaccess.IDataAccessObject;

import com.tcnd.wasdg.ejb.dataaccess.*;
import com.tcnd.wasdg.ejb.HmLookup;
// SER import com.tcnd.wasdg.ejb.MapRequest;
import java.util.Hashtable;

// import com.tcnd.wasdg.common.log.Log;
// import com.tcnd.wasdg.wasdgexceptions.WasdgException;

import java.rmi.RemoteException;
import javax.ejb.*;

public class IDACFetchTableBean implements SessionBean 
{
	private javax.ejb.SessionContext ctx = null;
	final static String jndiName = "DataAccessComponent";
	protected IDataAccessObject iDAO = null;
	protected DataAccessComponentRemote dacRemote = null;

	public void setSessionContext(javax.ejb.SessionContext ctx) { this.ctx = ctx; }
	public void ejbActivate() {} 
	public void ejbPassivate() {}
	public void ejbCreate() {} 
	public void ejbRemove() {}
	public javax.ejb.SessionContext getSessionContext() { return ctx; }


	public DataSet fetch(Hashtable mReq) throws javax.ejb.CreateException, java.rmi.RemoteException
	{
		DataSet ds = null;
		dacRemote = ((DataAccessComponentHomeRemote)HmLookup.getHome(jndiName)).create();
		iDAO = dacRemote.createDAObject();
		// >>>  initializeDAC();   // from DACBase
		String dbTable = mReq.get("tablename").toString();
		iDAO.setCommandString("SELECT * FROM DB2INST1." + dbTable);
		// iDAO = DAC.executeQuery(iDAO);
		// DataSet dataSet = iDAO.getDataSet();
		iDAO = dacRemote.executeQuery(iDAO);
		ds = iDAO.getDataSet();
		return ds;
	}
}
